function [A,B,C,dwA,dwB,dwC]=alignoverlap(X,D,nr_spec,nr_points)

b=zeros(nr_spec,6);

for k=1:nr_spec
    a=pinv(X)*D(k,:)';
    b(k,1)=a(1);
    b(k,2)=a(2);
    b(k,3)=a(3);
    b(k,4)=a(4);
    b(k,5)=a(5);
    b(k,6)=a(6);
end;

%%%%%% determine dw %%%%%%%%%%%%%%%%%%%%%

dwA=b(:,2)./b(:,1);
dwB=b(:,4)./b(:,3);
dwC=b(:,6)./b(:,5);

shiftdwA = dwA - floor(dwA);
shiftdwB = dwB - floor(dwB);
shiftdwC = dwC - floor(dwC);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% correct peaks A, B and C with dw %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%% A+dw ==>%%%%%%%%%%%%%%%
A=zeros(size(D));
B=zeros(size(D));
C=zeros(size(D));
E=zeros(size(D));
F=zeros(size(D));
G=zeros(size(D));

factor=zeros(nr_spec,1);

A=b(:,1)*X(:,1)';

for k=1:nr_spec
  B(k,:)=ifft(A(k,:));
end;

for k=1:nr_spec
  for l=1:nr_points
    C(k,l)=B(k,l)*exp(j*2*pi*l*dwA(k)/nr_points);
  end;
end;

for k=1:nr_spec
  E(k,1:nr_points/2) = C(k,1:nr_points/2)* exp(pi*i*shiftdwA(k));
  E(k,nr_points/2+1:nr_points) = C(k,nr_points/2+1:nr_points) * exp(-pi*i*shiftdwA(k));
end;


for k=1:nr_spec
  F(k,:)=fft(E(k,:));
end;


for k=1:nr_spec
  factor(k)=1/(cos(2*pi*(-dwA(k))/nr_points));
  G(k,:)=factor(k)*(cos(-shiftdwA(k)*pi)*real(F(k,:)) - sin(-shiftdwA(k)*pi)*imag(F(k,:)));
end;

A=G;
clear B C E F G;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%% B+dw ==>%%%%%%%%%%%%%%%

B=zeros(size(D));
C=zeros(size(D));
E=zeros(size(D));
F=zeros(size(D));
G=zeros(size(D));
H=zeros(size(D));

factor=zeros(nr_spec,1);

B=b(:,3)*X(:,3)';

for k=1:nr_spec
  C(k,:)=ifft(B(k,:));
end;

for k=1:nr_spec
  for l=1:nr_points
    E(k,l)=C(k,l)*exp(j*2*pi*l*dwB(k)/nr_points);
  end;
end;

for k=1:nr_spec
  F(k,1:nr_points/2) = E(k,1:nr_points/2)* exp(pi*i*shiftdwB(k));
  F(k,nr_points/2+1:nr_points) = E(k,nr_points/2+1:nr_points) * exp(-pi*i*shiftdwB(k));
end;


for k=1:nr_spec
  G(k,:)=fft(F(k,:));
end;


for k=1:nr_spec
  factor(k)=1/(cos(2*pi*(-dwB(k))/nr_points));
  H(k,:)=factor(k)*(cos(-shiftdwB(k)*pi)*real(G(k,:)) - sin(-shiftdwB(k)*pi)*imag(G(k,:)));
end;

B=H;
clear C E F G H;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%% C+dw ==>%%%%%%%%%%%%%%%

C=zeros(size(D));
E=zeros(size(D));
F=zeros(size(D));
G=zeros(size(D));
H=zeros(size(D));
I=zeros(size(D));

factor=zeros(nr_spec,1);

C=b(:,5)*X(:,5)';

for k=1:nr_spec
  E(k,:)=ifft(C(k,:));
end;

for k=1:nr_spec
  for l=1:nr_points
    F(k,l)=E(k,l)*exp(j*2*pi*l*dwC(k)/nr_points);
  end;
end;

for k=1:nr_spec
  G(k,1:nr_points/2) = F(k,1:nr_points/2)* exp(pi*i*shiftdwC(k));
  G(k,nr_points/2+1:nr_points) = F(k,nr_points/2+1:nr_points) * exp(-pi*i*shiftdwC(k));
end;


for k=1:nr_spec
  H(k,:)=fft(G(k,:));
end;


for k=1:nr_spec
  factor(k)=1/(cos(2*pi*(-dwC(k))/nr_points));
  I(k,:)=factor(k)*(cos(-shiftdwC(k)*pi)*real(H(k,:)) - sin(-shiftdwC(k)*pi)*imag(H(k,:)));
end;

C=I;
clear E F G H I;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
