function [newx]=correc_lineshape(x,range1,par1,par2);

% x is the original spetra;
% range1 is the frequency index of peaks;
% n is the number of the spectra which are used for phase and shift
% correction each time; par1 and par2 are frequency offsets used in
% the correction procedure.
% Reference: H. Witjes et al., J. Magn. Reson. 144, (2002) 35-44
%

newx=x;
[m]=size(x,1);
n=m-1;
for j=1:size(x,1)-n
  for i=1:size(range1,1)
  xa=x(j:j+n,range1(i,1):range1(i,2));
  [r,B,dphit,dwt]=alignment(xa);
  [newB,dwA] = lineshape(B,par1,par2,80); 
  newx(j:j+n,range1(i,1):range1(i,2))=newB;
  end
end
