function [newD,dwA] = lineshape(D,shift1,shift2,it);

% function [newD] = lineshape(D,shift1,shift2,it);
% this function is used to remove the lineshape variation after peak and
% phase shift correction;
% input: D is the original data;
%        shift1 and shift2 are the frequency offset for PC1 of D;
%        it is the number of iterations     
% Reference: H. Witjes et al., J. Magn. Reson. 144, (2002) 35-44


[nsample,nsignal]=size(D);

r=0;
while r<it
% calculate PC1;
  [P]=pca(D,nsignal);
  PC1=P(:,1)';
% add frequency offset to the PC1;
  [z1]=addfrequency(P(:,1)',shift1);
  [z2]=addfrequency(P(:,1)',shift2);

  PA=PC1;
  PB=z1;
  PC=z2;

  [X]=modeloverlap(PA,PB,PC,nsignal);

  [A,B,C,dwA,dwB,dwC]=alignoverlap(X,D,nsample,nsignal);

  D=A;
  r=r+1;
end

newD=A;








