function [c0,normc0]=opa(x1,ncom,range1,t);

%% function [c0,normc0]=opa(x1,ncom,range1,t);

%% Using Orthogonal Projection Approach(OPA) with seleted normalization method to find initial guesss;

%% Input parameters:
 % x1 is the 2D data set;
 % ncom is the estimated number of components;
 % range1 is the seleted range of the data, which should contain distinct signals;
 % t is the threshold of the variable norm or mean which high enough for normalisation;

%% Output parameters:
 % c0 is the selected pure variables, which is used for the initial guess.
 % normc0 is the normalised c0.
close all 
a=1:size(x1,2);

%define the range of interest;
%range1 is the selected frequency range of the data;
r=[];
for i=1:size(range1,1)
    r1=a(range1(i,1):range1(i,2));
    r=[r r1];
end
% display the numbers of the selected channels;
[mi,ni] = size(r);
s = sprintf('%g channels were selected',ni);
disp('  '), disp(s), disp('  ')

x=x1(:,r)';
%find the first purity variable;
%normxm=mean(x)./norm(mean(x));
[m,n]=size(x);
normx=zeros(m,n);
for i=1:m
  f(i)=mean(x(i,:));
%normx(i,:)=x(i,:)./(norm(x(i,:))+max(x(:,1)/5));
if f(i)>t
normx(i,:)=x(i,:)./norm(x(i,:));
else
normx(i,:)=x(i,:); 
end
end
normxm=mean(normx);

for i=1:m
  Y=[normxm' normx(i,:)'];
  d(i,1)=det(Y'*Y);
end

[mp,imp(1)]=max(d(:,1));
rimp(1)=r(imp(1));
disp('first purest variable:');disp(rimp(1));
D(1)=sum((d(2:end,1)-d(1:end-1,1)).^2)/sum(d(:,1).^2);


%find the second purity variable;
  for j=2:ncom
    for i=1:m
      Y=[normx(imp(1:j-1),:)' normx(i,:)'];
      d(i,j)=det(Y'*Y);
    end
    [mp(j),imp(j)]=max(d(:,j));
    rimp(j)=r(imp(j));
    disp('next purest variable:');disp(rimp(j))
    D(j)=sum((d(2:end,j)-d(1:end-1,j)).^2)/sum(d(:,j).^2);
    
  end


% plot the dissimilarity plot

for i=1:ncom
  subplot(ncom,1,i);plot(a(r),d(:,i));
end
title('disimilarity plot');
c0=x([imp],:)';

for i=1:size(c0,2)
  normc0(:,i)=c0(:,i)./norm(c0(:,i));
end

figure
subplot(1,2,1);plot(x([imp],:)');legend(num2str(rimp'));
title('Plot of the pure variables');
subplot(1,2,2);plot(normc0);legend(num2str(rimp'));
title('Plot of the normalised pure variables');
