function [I_shift1,K]=shift_data1;

% construct a DOSY data with peak shift and phase shift for DOSY data1;
% Writen by Ruifen Huo. (08/011/2003).

x=0:999;
a = [0.50; 0.50; 1.00; 0.50; 1.00];
f = [0.75; 0.52; 0.50; 0.48;  0.25];
d = [0.01; 0.01; 0.01; 0.01; 0.01];
p = [0; 0; 0; 0; 0];

for i=1:32
  A(:,i)=a;
  F(:,i)=f;
  P(:,i)=p;
end

%% give an offset for each phase and frequency;
n(1:20)=-0.75:0.75/19:0;n(21:32)=0;
pd1(1:12)=0; pd1(13:32)=-0.15;pd2(1:12)=0;pd2(13:32)=0.10;

for i=1:32
  F(:,i)=F(:,i)+0.0001*randn(1); % peak shift
  P(:,i)=P(:,i)+0.0087*randn(1);%phase shift
end  

%% give totally random phase and peak shift; 
A=A+0*randn(size(A));
F=F+0.000001*randn(size(F));

P=P+0.000087*randn(size(P));

% assign the pure decay profile C;
K=19321e+4:(64e+4-19321e+4)/31:64e+4; %true K
K=fliplr(K);K=K';



D=[5.00e-7, 5e-8, 1.00e-8];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%simulate non-gradient uniform
for i=1:32
  for j=1:1000
  K1(i,j)=K(i);
  end
end
K=K1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for j=1:(size(D',1))
  for i=1:32
  C(i,:,j)=exp(-D(j).*(.1-.005/3).*K(i,:));
end
end

for i=1:32
  [peak,realpeak] = nmrspec(A([3],i),F([3],i),d([3]),P([3],i),x);
  spectra1(i,:)=realpeak;
  
  comp1(i,:)=C(i,:,1).*spectra1(i,:);
  
  [peak,realpeak] = nmrspec(A([5 4 1],i),F([5 4 1],i),d([4 4 1]),P([5 4 1],i),x);
  spectra2(i,:)=sum(realpeak);
  comp2(i,:)=C(i,:,2).*spectra2(i,:);
  
  [peak,realpeak] = nmrspec(A([5,2],i),F([5,2],i),d([5,2]),P([5,2],i),x);
  spectra3(i,:)=sum(realpeak);
  comp3(i,:)=C(i,:,3).*spectra3(i,:);
end

I_shift1=comp1+comp3+comp2;

I_shift1=I_shift1+0.02*randn(size(I_shift1));

K=K(:,1);

