function [I_shift,K]=shift_dosydata;

% function [I_shift,K]=shift_dosydata;
% construct a dosy data I_shift with peak shift and phase shift;
% written by Ruifen Huo. (08/07/2002)

x=0:999;
a = [0.50; 0.50; 1.00; 0.50; 1.00];
f = [0.75; 0.52; 0.50; 0.48;  0.25; 0.24;0.40];
d = [0.01; 0.02; 0.04; 0.05; 0.08];
p = [0; 0; 0; 0; 0];

for i=1:32
  A(:,i)=a;
  F(:,i)=f;
  P(:,i)=p;
end

% give an offset for each phase and frequency;

for i=1:32
  F(:,i)=F(:,i)+0.00002*randn(1);
  P(:,i)=P(:,i)+0.00022*randn(1);
end


A=A+0*randn(size(A));
F=F+0.00000002*randn(size(F));

P=P+0.000000035*randn(size(P));

% assign the pure decay profile C;
K=19321e+4:(64e+4-19321e+4)/31:64e+4;
%K=K.^2; ...

n=zeros(1,32);
n(1:11)=0:10; n(12:20)=11:1.5:23; n(21:32)=24.5:2:46.5;
K=fliplr(K);K=K';K2=K;
K1=zeros(32,1000);
for i=1:32
  for j=1:1000
    K1(i,j)=K(i)-0.003*n(i)*K(i);
  end
end

K2=K1+1e5*randn(size(K1));


D=[8.00e-8,5e-7,1.00e-7,2e-7];

for j=1:(size(D',1))
  for i=1:32
  C(i,:,j)=exp(-D(j).*(.1-.005/3).*K(i,:));
end
end

for i=1:32
  [peak,realpeak] = nmrspec(A([3],i),F([3],i),d([3]),P([2],i),x);
  spectra1(i,:)=realpeak;
  spectra1_c(i,:)=spectra1(i,:)-0.505;
  comp1(i,:)=C(i,:,1).*spectra1_c(i,:);

  [peak,realpeak] = nmrspec(A([5 4 1],i),F([5 4 1],i),d([4 4 1]),P([5 4 1],i),x);
  spectra2(i,:)=sum(realpeak);
  spectra2_c(i,:)=spectra2(i,:)-1.0342;
  comp2(i,:)=C(i,:,2).*spectra2_c(i,:);
  
  [peak,realpeak] = nmrspec(A([4,2],i),F([6,2],i),d([1,1]),P([5,2],i),x);
  spectra3(i,:)=sum(realpeak);
  spectra3_c(i,:)=spectra3(i,:)-0.5041;
  comp3(i,:)=C(i,:,3).*spectra3_c(i,:);
  
  [peak,realpeak] = nmrspec(A([4,5],i),F([4,7],i),d([4,5]),P([4,4],i),x);
  spectra4(i,:)=sum(realpeak);
  spectra4_c(i,:)=spectra4(i,:)-0.7785;
  comp4(i,:)=C(i,:,4).*spectra4_c(i,:);
end

I_shift1=comp1+comp3+comp2+comp4;

I_shift=I_shift1+0.02*randn(size(I_shift1));


  
  
