function [data_cor_baseline]=spec_baseline(data,n,N,m);

% data is a Dosy data set;
% n is the multiplier of the SD for recognising the points of baseline
% N is the window width for the same purpose;
% m is the window width for smoothing of the spectra;
% written by Ruifen Huo (19/11/2002)
[r,c]=size(data);
a=(N-1)/2;

data_baseline=zeros(size(data));
% Calculate the x_baseline of the first spectrum of "data"
[I,sigma_noise,x_baseline,xcorr]=baseline_reco(data(1,:),n,N,m);
data_baseline(1,:)=x_baseline;

for i=2:r
  % smooth the original 'data';
  for j=m+1:c-m
    smoodata(i,j)=sum(data(i,j-m:j+m))/(2*m+1);
  end
  
 data_baseline(i,I)=smoodata(i,I);
 
 for j=1:size(I,2)-1
   if I(j+1)-I(j)>1
     yb=data_baseline(i,[I(j) I(j+1)])';
     xb=[I(j) 1;I(j+1) 1];
     [Q, R]=qr(xb,0);
     b = R\(Q'*yb);
     xc=I(j):I(j+1);
     yc=b(1)*xc+b(2);
     data_baseline(i,I(j):I(j+1))=yc;
   end
 end
 data_baseline(i,1:m)=data_baseline(i,m+1:2*m);
 data_baseline(i,c-m+1:c)=data_baseline(i,c-2*m:c-m-1);
end

 data_cor_baseline=data-data_baseline;
 
for i=1:r
  data_cor_baseline(i,1:a+10)=data_cor_baseline(i,a+11:2*a+20);
  data_cor_baseline(i,c-a-9:c)=data_cor_baseline(i,a+11:2*a+20);
end

  
     
  
